/*==============================================*/
/*  Rectangles.c - Draw Some Rectangles         */
/*                                              */
/*  Demo how to use INTEGER coordinates         */
/*                                              */
/*  Author:  Bary W Pollack                     */
/*  Updated: Feb. 16, 2004                      */
/*==============================================*/

#include <GL/glut.h>

/*==============================================*/

void display (void)         /* the display callback */
{
    int  i, d;

    glClear (GL_COLOR_BUFFER_BIT);

    /* create 7 nested rectangles with colored corners               */
    /* actually, they're squares -- but, if you resize the window... */
    for (i = 0; i < 7; i++)
    {
        /* draw a rectangle */
        glLineWidth (2.0 + i);
        glBegin (GL_LINE_LOOP);
            glColor3f (0.0, 0.0, 0.0);
            d = 3 * i;
            glVertex2i (10+d, 10+d);  glVertex2i (50-d, 10+d);
            glVertex2i (50-d, 50-d);  glVertex2i (10+d, 50-d);
        glEnd ();

        /* put points at the 4 vertices */
        glPointSize (4.0 + i);
        glBegin (GL_POINTS);
            glColor3f (0.0, 0.0, 1.0);
            d = 3 * i;
            glVertex2i (10+d, 10+d);  glVertex2i (50-d, 10+d);
            glVertex2i (50-d, 50-d);  glVertex2i (10+d, 50-d);
        glEnd ( );
    }

    glFlush ();
}

/*==============================================*/

void myinit ()      /* standard initialization for OpenGL and GLUT */
{
    GLfloat fVSize = 60;
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    gluOrtho2D (-0.2, fVSize + 0.2, -0.2, fVSize + 0.2);
    glMatrixMode (GL_MODELVIEW);
    glClearColor  (0.6, 9.0, 0.7, 1.0);
    glPointSize (5.0);
}

/*==============================================*/

int main (int argc, char **argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB );
    glutInitWindowSize (500, 500);
    glutInitWindowPosition (25, 50);
    glutCreateWindow ("Rectangles");
    glutDisplayFunc (display);
    myinit ();
    glutMainLoop ();

    return 0;
}

/*==============================================*/

